<template>
  <div class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator=">">
      <template v-if="authType">
        <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined && currentTeachingClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined && currentStudyingClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined && currentPreviewClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentOpenPreviewClass(classId) !== undefined && currentOpenPreviewClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentOpenPreviewClass(classId).name }}</el-breadcrumb-item>
      </template>
      <template v-if="!authType">
        <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined && currentTeachingClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined && currentStudyingClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined && currentPreviewClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentOpenPreviewClass(classId) !== undefined && currentOpenPreviewClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentOpenPreviewClass(classId).name }}</el-breadcrumb-item>
      </template><el-breadcrumb-item>{{ $t('CLASS_MENU.BOARD') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
        </a>
      </div> 
    </el-breadcrumb>
    <h1> {{ name }} </h1>
    <hr>

    <editor-content :editor="editor" :style="`height: ${height}; overflow-y: scroll; margin-bottom: 20px;`"/>

    <el-button v-if="isPostOwner" @click="onClick('DELETEPOST')" type="danger" plain style="float: right;">{{ $t('LECTURE_LIST.DELETE') }}</el-button>
    <el-button v-if="isPostOwner" @click="onClick('MODIFY')" plain style="float: right;">{{ $t('LECTURE_LIST.EDIT') }}</el-button>
    <el-button @click="onClick('CANCEL')" plain>{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
    <p></p>
    <p></p>
    <div v-if="fileLength > 0">
      <hr>
      <h4>{{ $t('BOARD.ATTACH_FILE') }}</h4>
      <div :key="file.file_guid" v-for="file in post.files" style="margin: 20px 0px 20px 10px;">
        <span>{{ $t('MATERIAL.NAME') }} : {{ file.name }} </span>
        <el-button @click="onClick('DOWNLOAD',file.client_path,file.name)">{{ $t('DOWNLOAD.DOWN') }}</el-button>
      </div>
    </div>
    <hr>
    <div style="width: 100%">
      <el-input v-model="comment" :placeholder="$t('BOARD.ENTER_COMM')">
        <el-button slot="append" @click="onClick('SAVECOMMENT')" type="text" style="width: 100px">{{ $t('BOARD.SAVE_COMM') }}</el-button>
      </el-input>
    </div>
    <div :key="reply.board_reply_id" v-for="reply in post.board_replies" style="margin: 20px 0px 20px 10px;">
      <span>{{ reply.user.name }}  :  {{ reply.content }}</span>
      <el-button v-if="reply.writer_id === jwtUserId" @click="onClick('DELETECOMMENT',reply.board_reply_id, reply.writer_id, jwtUserId)" type="danger" size="small" plain>X</el-button>
      <hr>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex';
import { Editor, EditorContent } from 'tiptap';
import {
  Blockquote,
  CodeBlock,
  HardBreak,
  Heading,
  OrderedList,
  BulletList,
  ListItem,
  TodoItem,
  TodoList,
  Bold,
  Code,
  Italic,
  Link,
  Strike,
  Underline,
  History,
} from 'tiptap-extensions';
import utils from '../../utils';
import { baseUrl } from '../../services/config';

export default {
  async created() {
    const vm = this;
    await vm.getPost({
      classId: vm.$route.params.classId,
      boardId: vm.$route.params.boardId,
    });
    vm.$data.name = vm.post.name;
    vm.editor.setContent(vm.post.content);
    vm.$data.fileLength = vm.post.files.length; // 직접 대입하면 url로 바로 호출시, undefined 오류가 발생하여(?) 임시처리
    vm.$data.jwtUserId = utils.getUserIdFromJwt();
    if (vm.post.writer_id === vm.$data.jwtUserId) {
      vm.$data.isPostOwner = true;
    }
    let height = window.innerHeight || document.body.clientHeight;
    vm.height = `${(height * 0.35)}px`;
  },
  components: {
    EditorContent,
  },
  computed: {
    ...mapState('board', [
      'post',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
      'currentStudyingClass',
      'currentPreviewClass',
      'currentOpenPreviewClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  methods: {
    ...mapActions('board', [
      'getPost',
      'deletePost',
      'setModifyMode',
      'postReply',
      'deleteReply',
    ]),
    async onClick(type, arg, arg2) {
      const vm = this;
      switch (type) {
        case 'SAVECOMMENT': {
          await vm.postReply({
            boardId: this.$route.params.boardId,
            content: this.$data.comment,
          });
          this.$data.comment = '';
          break;
        }
        case 'CANCEL': {
          await vm.$router.go(-1);
          break;
        }
        case 'MODIFY': {
          vm.setModifyMode({
            flag: true,
          });
          await vm.$router.push(`/v4/test2/${this.$route.params.classId}/test2NNClassQestionAnswerWrite`);
          break;
        }
        case 'DELETEPOST': {
          vm.$confirm(vm.$t('BOARD.DEL_CHECK'), {
            confirmButtonText: vm.$t('NOTE.CONFIRM'),
            cancelButtonText: vm.$t('NOTIFY.CANCEL'),
            type: 'warning',
          })
          .then(async () => {
            try {
              await vm.deletePost({
                classId: this.$route.params.classId,
                boardId: this.$route.params.boardId,
              });
              await vm.$router.go(-1);
            } catch (error) {
              vm.$notify({
                title: vm.$t('BOARD.DEL_POST_FAIL'),
                message: error.toString(),
                type: 'error',
                duration: 3000,
              });
            }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t('NOTIFY.CANCELLED'),
              message: vm.$t('BOARD.DEL_POST_CANCEL'),
              type: 'info',
              duration: 3000,
            });
          });
          break;
        }
        case 'DELETECOMMENT': {
          await vm.deleteReply({
            boardId: this.$route.params.boardId,
            replyId: arg,
          });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
        case 'DOWNLOAD': {
          utils.downloadFile(baseUrl, {
            client_path: arg,
            name: arg2
          });
          break;
        }
      }
    },
  },
  data() {
    return {
      name: '',
      content: '',
      comment: '',
      fileGuid: 'mock',
      isPostOwner: false,
      jwtUserId: '',
      fileLength: 0,
      editor: new Editor({
        extensions: [
          new Blockquote(),
          new CodeBlock(),
          new HardBreak(),
          new Heading({ levels: [1, 2, 3] }),
          new BulletList(),
          new OrderedList(),
          new ListItem(),
          new TodoItem(),
          new TodoList(),
          new Bold(),
          new Code(),
          new Italic(),
          new Link(),
          new Strike(),
          new Underline(),
          new History(),
        ],
        editable: false,
      }),
      height: '0',
    };
  },
};
</script>